import pygame
import colorsys
import os, sys
import random
import pygame.mixer
import classes.extras as ex
sounds = pygame.mixer
sounds.init()

#sound_1 = '7971__cfork__plopp.ogg'#'8006__cfork__cf-fx-flopp-03-dry.ogg'
#sound_1 = '7971__cfork__plopp.ogg'#ok
#sound_2 = '8000__cfork__cf-fx-bloibb.ogg'#no
#sound_3 = '8001__cfork__cf-fx-doppp-01.ogg'#ok
#sound_4 = '8002__cfork__cf-fx-doppp-02.ogg'#no
#sound_5 = '8003__cfork__cf-fx-doppp-03-dry.ogg'#ok
sound_6 = '8004__cfork__cf-fx-flopp-01.ogg'#no
#sound_7 = '8005__cfork__cf-fx-flopp-02-juicy.ogg'#ok
sound_8 = '8006__cfork__cf-fx-flopp-03-dry.ogg'#mouse drag
#sound_9 = '8007__cfork__cf-fx-flopp-04-bass.ogg'#too loud
#sound_10 = '8008__cfork__cf-fx-plopp-01.ogg'#ok
#sound_11 = '8009__cfork__cf-fx-plopp-02.ogg'#ok

s1 = sounds.Sound(os.path.join('sounds', sound_8))
s2 = sounds.Sound(os.path.join('sounds', sound_6))

"""
Grid sized optimized for 1024x786 screens:
[[5, 3],[6, 4],[7, 4],[8, 5],[9, 6],[10, 7],[11, 7],[12, 8],[13, 9],[14, 9],[15, 10],[16, 11],[17, 11],[18, 12],[19, 13],[20, 14],[21, 14],[22, 15],[23, 16],[24, 16],[25, 17],[26, 18],[27, 19],[28, 19],[29, 20],[30,21]]
"""

class Unit(pygame.sprite.Sprite):
    'basic class for all on-board objects'
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="",color=(0,0,0),**kwargs):
        # Call the parent's constructor
        pygame.sprite.Sprite.__init__(self)

        #grid location and size
        self.grid_x = grid_x
        self.grid_y = grid_y
        self.grid_w = grid_w
        self.grid_h = grid_h
        self.board = board
        self.initcolor = color 
        self.color = color
        self.locked = False
        self.value = value
        self.outline = False
        self.perm_outline = False
        self.perm_outline_color = [255,0,0]
        self.perm_outline_width = 2
        self.hasimg = False
        self.draggable = True
        self.show_value = True
        self.readable = True
        self.highlight = True
        self.outline_highlight = False
        self.font_color = (0,0,0,0)
        
        # Set height, width, the -1 is to give it some space around for the margin
        self.image = pygame.Surface([grid_w*board.scale-1, grid_h*board.scale-1])
        self.image.fill(self.color)
        self.painting = self.image
 
        # Make our top-left corner the passed-in location. The +1 is the margin
        self.rect = self.image.get_rect()
        self.rect.topleft = [grid_x*board.scale+1,grid_y*board.scale+1]

        #scale font size:
        #self.points = int(round((board.scale * 72 /96)*1.5,0))
        #self.font = pygame.font.Font(None, (self.points))
        self.font = board.font_sizes[0]
        
        #self.set_outline([155,0,0],1)
        
    @property
    def grid_pos(self):
        return [self.grid_x, self.grid_y]
    
    # Update color, image or text
    def update(self, board, **kwargs):
        self.image.fill(self.color)
        self.image.blit(self.painting,(0,0))
        if self.hasimg == False:
            if len(self.value) > 0:
                if self.show_value:
                    if isinstance(self.value, str):
                        #if a passed argument is a string turn it into a 1 item list
                        value = [self.value]
                    else:
                        value = self.value
                    lv = len(value)
                    #if lv == self.grid_h: #number of items is equal to grid height of an object
                    for i in range(lv):
                        text = self.font.render("%s" % (value[i]), 1, self.font_color)
                        font_x = ((board.scale*self.grid_w-self.font.size(value[i])[0])//2)
                        if lv == 1:
                            font_y = ((board.scale*self.grid_h-self.font.size(value[i])[1])//2)
                        elif lv == self.grid_h: #number of items is equal to grid height of an object - distribute lines equally in each grid square
                            font_y = ((board.scale-self.font.size(value[i])[1])//2)+board.scale*i
                        self.image.blit(text, (font_x,font_y))
                            
                        """
                        #number of items is equal to grid height of an object
                        self.text = self.font.render("%s" % (self.value), 1, self.font_color)
                        self.font_x = ((board.scale*self.grid_w-self.font.size(self.value)[0])//2)
                        self.font_y = ((board.scale*self.grid_h-self.font.size(self.value)[1])//2)
                        self.image.blit(self.text, (self.font_x,self.font_y))
                        """
        if self.perm_outline:
            self.draw_outline()
                    
    @property
    def reversed_color(self):
        return [int(each / 1.5) for each in reversed(self.initcolor)]

    @property
    def brighter(self):
        if self.highlight:
            color = [each / 255.0 for each in self.initcolor]
            hsv = colorsys.rgb_to_hsv(*color)
            rgb = colorsys.hsv_to_rgb(hsv[0],1,1)
            return [int(each*255) for each in rgb]
        else:
            return self.initcolor

    def turn(self,d):
        pass
     
    def rot_center(self, image, angle):
        """rotate an image while keeping its center and size"""
        orig_rect = image.get_rect()
        rot_image = pygame.transform.rotate(image, angle)
        rot_rect = orig_rect.copy()
        rot_rect.center = rot_image.get_rect().center
        rot_image = rot_image.subsurface(rot_rect).copy()
        return rot_image
        
    def draw_outline(self):
        "draws an 'out'line around the unit"
        color = self.perm_outline_color#[255,0,0]
        width = self.perm_outline_width
        if width > 1:
            x = width // 2-1
            y = width // 2-1
            if width % 2 == 0:
                w2 = width // 2 + 2
            else:
                w2 = width // 2 + 1
        elif width == 1:
            x = 0
            y = 0
            w2 = 2

        pygame.draw.lines(self.image, color, True, [[x,y],[self.board.scale*self.grid_w-w2,y],[self.board.scale*self.grid_w-w2,self.board.scale*self.grid_h-w2],[x,self.board.scale*self.grid_h-w2]],width)
        
    def set_outline(self, color = [255,0,0], width = 2):
        'enables the draw_outline and sets line color and width'
        self.perm_outline = True
        if color == 0 and hasattr(self,"door_outline") == False: #if color is 0 calculate colour from base colour
            #convert to hsv
            c = self.color
            h, s, v = ex.rgb_to_hsv(c[0],c[1],c[2])
            outline_color =  ex.hsv_to_rgb(h,s+50,v-50)
            self.perm_outline_color = outline_color
        elif color == 1:
            c = self.color
            h, s, v = ex.rgb_to_hsv(c[0],c[1],c[2])
            outline_color =  ex.hsv_to_rgb(h,s+20,v-20)
            self.perm_outline_color = outline_color
        else:
            self.perm_outline_color = color
        self.perm_outline_width = width
        self.init_pow = width
        
class Obstacle(Unit):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="", initcolor = (23,157,255),**kwargs):
        self.initcolor = initcolor
        Unit.__init__(self,board,grid_x,grid_y,grid_w,grid_h,"0",self.initcolor,**kwargs)
        self.unit_id = len(board.units)
        self.value = value

class Label(Obstacle):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="",initcolor = (255,157,23),font_size=0,**kwargs):
        Obstacle.__init__(self,board,grid_x,grid_y,grid_w,grid_h,value,initcolor,**kwargs)
        #txt_len = len(self.value)
        self.font = board.font_sizes[font_size]
            
    def update(self, board, **kwargs):
        Unit.update(self,board)

class Ship(Unit):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="",initcolor = (255,157,23),**kwargs):
        self.initcolor = initcolor
        Unit.__init__(self,board,grid_x,grid_y,grid_w,grid_h,value,self.initcolor,**kwargs)
        self.unit_id = len(board.ships)
        
    def move(self,board,x,y):
        board.move(self.unit_id,x,y)

    def update(self, board, point,**kwargs):
        Unit.update(self,board)
        if self.locked == True:
            self.draw_circle(board, point)

    def enable_circle(self):
        self.locked = True

    def disable_circle(self):
        self.locked = False
        
    def draw_circle(self,board,point):
        max_radius = board.scale // 2
        step = max_radius // 4
        color = self.reversed_color
        for i in range(1,4):
            try:
                pygame.draw.ellipse(self.image, color, ((point[0]+step,point[1]+step),(board.scale-step*2,board.scale-step*2)), 1)
                step += step
            except ValueError:
                pass
        pygame.draw.line(self.image, color,[point[0]+board.scale//2,point[1]],[point[0]+board.scale//2,point[1]+board.scale],1)
        pygame.draw.line(self.image, color,[point[0],point[1]+board.scale//2],[point[0]+board.scale,point[1]+board.scale//2],1)

        
class Letter(Ship):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="",initcolor = (255,157,23),font_size=0,**kwargs):
        Ship.__init__(self,board,grid_x,grid_y,grid_w,grid_h,value,initcolor,**kwargs)
        self.font = board.font_sizes[font_size]

    def update(self, board, **kwargs):
        Unit.update(self,board)        
            
class ImgShip(Ship):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="",initcolor = (255,157,23), img_src='',**kwargs):
        Ship.__init__(self,board,grid_x,grid_y,grid_w,grid_h,value,initcolor,**kwargs)
        self.img_src = img_src
        if len(self.img_src) > 0:
            self.hasimg = True
            self.img = self.image
            self.img_pos = (0,0)
            self.outline = True
            try:
                self.img_org = pygame.image.load(os.path.join('images', self.img_src)).convert()
                self.img = self.img_org
                self.img_rect = self.img.get_rect()
                #if image size is larger than the sprite or is too small than resize
                size_diff = self.rect.w - self.img_rect.w                
                if  size_diff < 0:
                    self.img = self.img_org = pygame.transform.smoothscale(self.img, (self.rect.w-2, self.rect.h-2))
                elif size_diff > 7:
                    self.img = self.img_org = pygame.transform.smoothscale(self.img, (self.rect.w-7, self.rect.h-7))
                
                self.img_rect = self.img.get_rect()                
                pos_x = ((board.scale*self.grid_w-self.img_rect.w)//2)
                pos_y = ((board.scale*self.grid_h-self.img_rect.h)//2)
                self.img_pos = (pos_x,pos_y)
            except:
                pass

        self.image.set_colorkey(self.initcolor)

    def update(self, board, **kwargs):
        Unit.update(self,board)
        if len(self.img_src) > 0:
            self.image.blit(self.img, self.img_pos)
        if self.unit_id == board.active_ship and self.outline == True:
            lines = [[0,0],[self.grid_w*board.scale-2,0],[self.grid_w*board.scale-2,self.grid_h*board.scale-2],[0,self.grid_h*board.scale-2]]
            pygame.draw.lines(self.image, (255, 200, 200), True, lines)
        if hasattr(self, "door_outline") and self.door_outline == True:
            #lines = [[0,0],[self.grid_w*board.scale-3,0],[self.grid_w*board.scale-3,self.grid_h*board.scale-3],[0,self.grid_h*board.scale-3],[0,0]]
            #pygame.draw.lines(self.image, (200, 100, 100), False, lines,2)
            #lines = [[1,1],[self.grid_w*board.scale-3,1],[self.grid_w*board.scale-3,self.grid_h*board.scale-3],[1,self.grid_h*board.scale-3]]
            #pygame.draw.lines(self.image, (255, 0, 0), True, lines,2)
            self.set_outline([255,0,0],2)
        if self.perm_outline:
            self.draw_outline()
    
    @property
    def brighter(self):
        return self.color
        
class MultiImgSprite(ImgShip):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="",initcolor = (255,157,23), img_src='',frame_flow=[0], frame_count=1, **kwargs):
        ImgShip.__init__(self,board,grid_x,grid_y,grid_w,grid_h,value,initcolor,**kwargs)
        self.img_src = img_src
        if len(self.img_src) > 0:
            self.hasimg = True
            self.img = self.image
            self.img_pos = (0,0)
            self.outline = False
            self.draggable=False
            self.correction = False
            self.frame_w = grid_w*board.scale
            self.frame_flow = frame_flow
            self.frame_count = frame_count
            
            self.frame = 0
            try:
                self.img_org = pygame.image.load(os.path.join('images', self.img_src)).convert()
                self.img = self.img_org
                self.img_rect = self.img.get_rect()
                
                #image size is most likely different than the sprite so resize is needed
                #size_diff = self.rect.h - self.img_rect.h                
                new_h = self.rect.h
                new_w = self.rect.h * self.img_rect.w // self.img_rect.h
                self.img = self.img_org = pygame.transform.smoothscale(self.img, (new_w, new_h))

                self.img_rect = self.img.get_rect()                
                pos_x = 0
                pos_y = 0
                self.img_pos = (pos_x,pos_y)
            except:
                pass

    def next_frame(self):
        if self.frame < self.frame_count-1:
            self.frame += 1
        else:
            self.frame = 0
        self.img_pos = (-(self.frame_flow[self.frame]*(self.frame_w-1)),0)
    
    def set_frame(self, frame):
        self.frame = frame
        if self.correction:
            #shift the image by 1px to the right every 3 frames - to carter for some kind of a scaling problem with very long images
            shift = self.frame // 3
        else:
            shift = 0
            
        self.img_pos = (-(self.frame_flow[self.frame]*(self.frame_w-1))+shift,0)
    
    def build_frame_flow(self,frame_count):
        self.frame_count = frame_count
        self.frame_flow = [i for i in range(self.frame_count)]
        
    def reset(self):
        self.img_pos = (0,0)
        self.frame = 0
        
class Door(ImgShip):
    def set_pos(self,pos):
        self.grid_x = pos[0]
        self.grid_y = pos[1]
        self.rect.topleft = [pos[0]*self.board.scale+1,pos[1]*self.board.scale+1]

class SlidingDoor(MultiImgSprite):
    def set_pos(self,pos):
        self.grid_x = pos[0]
        self.grid_y = pos[1]
        self.rect.topleft = [pos[0]*self.board.scale+1,pos[1]*self.board.scale+1]

        
class PickUp(ImgShip):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="",initcolor = (255,255,255), img_src='',**kwargs):
        ImgShip.__init__(self,board,grid_x,grid_y,grid_w,grid_h,value,initcolor,**kwargs)
        self.img_src = img_src
        door_outline = False
        if len(self.img_src) > 0:
            self.img = self.image
            self.img_pos = (0,0)
            try:
                self.img_org = pygame.image.load(os.path.join('images', self.img_src)).convert()
                self.img_pos = (0,0)
                self.img = self.img_org
            except:
                pass
            
class ImgShipRota(ImgShip):
    def turn(self,d):
        if d == [0,-1]:#up
            self.img = self.img_org
        elif d == [0,1]:#down
            self.img = self.rot_center(self.img_org, 180)
        elif d == [1,0]: #right
            self.img = self.rot_center(self.img_org, 270)
        elif d == [-1,0]: #left
            self.img = self.rot_center(self.img_org, 90)

class AIUnit(ImgShipRota):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="",initcolor = (255,157,23),**kwargs):
        self.initcolor = initcolor
        ImgShipRota.__init__(self,board,grid_x,grid_y,grid_w,grid_h,value,self.initcolor,**kwargs)
        self.unit_id = len(board.aiunits)
        self.prev_pos = [grid_x,grid_y]
        self.now_pos  = [grid_x,grid_y]
        #self.move_dir  = 
        self.change_dir([[0,1],[1,0],[0,-1],[-1,0]])
        
    def change_dir(self, possible):
        #possible_dirs = possible #[[0,1],[1,0],[0,-1],[-1,0]]
        self.move_dir = possible[random.randrange(len(possible))]
        
class BoardBg(Unit):
    #def update(self,screen,color,screen_w,screen_h,grid_line_w):
    def __init__(self,board,grid_x=0,grid_y=0,grid_w=1,grid_h=1,value="", initcolor = (255,255,255),**kwargs):
        self.initcolor = initcolor        
        Unit.__init__(self,board,grid_x,grid_y,grid_w,grid_h,"0",self.initcolor,**kwargs)
        self.rect.topleft = [0,0]        
        #gb = self.board.mainloop.game_board
        #game,self.cl_grid_line,l.screen_w-l.menu_w,l.game_h,l.grid_line_w
        color = (240, 240, 240)#gb.cl_grid_line
        screen_w = self.board.x_count * self.board.scale # gb.l.screen_w-gb.l.menu_w
        screen_h = self.board.y_count * self.board.scale
        grid_line_w = 1
        screen = self.painting
        screen.fill(self.initcolor)
        if self.board.draw_grid:
            for row in range(self.board.x_count+1): #draw vertical lines
                pygame.draw.line(screen,color,[row*self.board.scale,0],[row*self.board.scale,screen_h],grid_line_w)
            for column in range(self.board.y_count+1): #draw horizontal lines
                pygame.draw.line(screen,color,[0,column*self.board.scale],[screen_w,column*self.board.scale],grid_line_w)

class Board:
    'Initializes and creates an empty board with the sizes given, ie. a=Board(10,10,50)'
    def __init__(self,mainloop,x_count=10,y_count=10,scale=8):
        self.mainloop = mainloop
        self.draw_grid = True
        self.level_start(x_count,y_count,scale)
        self.s1 = s1
        #self.dirty = False
        #self.update_all = True
        
    def level_start(self,x_count,y_count,scale):
        self.grid  = []     #square availability list
        self.ships = []     #list of movable objects on board
        self.units = []     #list of non moving units
        self.aiunits = []
        self.ai_enabled = False
        self.x_count=x_count #number of columns
        self.y_count=y_count #number of rows
        self.scale = scale  #number of pixels per grid unit
        self._create_board(x_count,y_count)
        self.active_ship = -1
        self.board_changed = False
        # This is a list of 'sprites.' Each block in the program is
        # added to this list. The list is managed by a class called 'RenderPlain.'
        self.unit_list = pygame.sprite.LayeredUpdates()
        self.ship_list = pygame.sprite.LayeredUpdates()
        # This is a list of every sprite. All blocks and the player block as well.
        self.all_sprites_list = pygame.sprite.LayeredUpdates()#pygame.sprite.RenderPlain()
        self.sprites_to_draw = pygame.sprite.RenderPlain()
        #scaling and creating font sizes:
            

        self.points = int(round((self.scale * 72 /96)*1.5,0))
        """        
        #sizes= [0 1    2   3    4 5    6   7    8 9   10 11-hw 12-hw]
        """
        sizes = [1,1.25,1.5,1.75,2,2.25,2.5,2.75,3,3.5,4]
        #self.font_sizes[0:10]        
        self.font_sizes = [pygame.font.Font(None, (int(float(self.points)/float(sizes[i])))) for i in range(len(sizes))]
        #self.font_sizes[11]        
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDM___.TTF'), int(self.points/2)))
        #self.font_sizes[12]        
        #self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDG___.TTF'), round(self.points/2)))        
        #self.font_sizes[12]        
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDC___.TTF'), self.points))
        #self.font_sizes[13]        
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDG___.TTF'), self.points))  
        #if self.mainloop.m.game_constructor == game045.Board:
        #self.font_sizes[14] - extra large for learn to write game
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDE___.TTF'), self.points*11))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDE___.TTF'), self.points*7))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDE___.TTF'), self.points*5))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDE___.TTF'), self.points*3))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDROAD.TTF'), self.points*11))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDROAD.TTF'), self.points*7))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDROAD.TTF'), self.points*5))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDROAD.TTF'), self.points*3))

        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDM___.TTF'), self.points*4))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDM___.TTF'), self.points*4))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDM___.TTF'), self.points*3))
        self.font_sizes.append(pygame.font.Font(os.path.join('fonts', 'hand', 'HANDM___.TTF'), self.points*2))
            
        #hand_writting = pygame.font.Font(os.path.join('fonts', 'hand', ''), self.points)
        #pygame.font.Font(object, size): return Font
        #self.font_sizes_hand_written = [pygame.font.Font(hand_writting, (round(self.points/sizes[i]))) for i in range(len(sizes))]
        
        self.board_bg = BoardBg(self,0,0,x_count,y_count,"",(255,255,255))
        self.unit_list.add(self.board_bg)
        self.all_sprites_list.add(self.board_bg)
        
    def update_layout(self,scale):
        pass
            
    def clean(self):
        self.unit_list.empty()
        self.ship_list.empty()
        self.all_sprites_list.empty()
        self.sprites_to_draw.empty()
        del(self.ships)
        del(self.units)
        del(self.aiunits)
        del(self.unit_list)
        del(self.ship_list)
        del(self.all_sprites_list)
        del(self.sprites_to_draw)
        
    def _create_board(self,sx,sy):
        'Creates an empty board for the initialisation method'
        self.grid = [[0 for x in range(0,sx)] for y in range(0,sy)]

    def draw_board(self,screen,color,screen_w,screen_h,grid_line_w): # call with: board.draw_board(screen,cl_grid_line,screen_w,screen_h,grid_line_w)
        pass
        """        
        if self.draw_grid:
            for row in range(self.x_count+1): #draw vertical lines
                pygame.draw.line(screen,color,[row*self.scale,0],[row*self.scale,screen_h],grid_line_w)
            for column in range(self.y_count+1): #draw horizontal lines
                pygame.draw.line(screen,color,[0,column*self.scale],[screen_w,column*self.scale],grid_line_w)
        """
    def _reset_board(self):
        'Sets all fields on Board to False'
        self.grid = [[0 for x in range(0,self.x_count)] for y in range(0,self.y_count)]

    def _set(self,x,y,grid_w=1,grid_h=1,value=1):
        'Take/Reserve the position on board if True, or free position if False'
        'Before using this method use the _isfree() method first check if all squares in question are available and than go back to each field and set as True'
        x2=x+grid_w
        y2=y+grid_h
        for i in range(x,x2):
            for j in range(y,y2):
                self.grid[j][i]=value

    def _isfree(self,x,y,grid_w=1,grid_h=1):
        'check if the position is free and within board'
        x2=x+grid_w
        y2=y+grid_h

        #if position + size is within board
        if (0 <= x < x2 <= self.x_count) and (0 <= y < y2 <= self.y_count):            
            for i in range(x,x2):
                for j in range(y,y2):
                    if self.grid[j][i]==True:
                        return False
            return True
        return False

    def add_unit(self, grid_x=0, grid_y=0, grid_w=1, grid_h=1, unit_class=Ship, value="A", color=(0,0,0), img_src='',font_size=0,frame_flow=[0],frame_count=1):
        'adds a new unit to the board'
        if self._isfree(grid_x,grid_y,grid_w,grid_h):
            unit = unit_class(self,grid_x,grid_y,grid_w,grid_h,value,initcolor=color,img_src = img_src,font_size = font_size,frame_flow = frame_flow,frame_count=frame_count)
            if isinstance(unit, Ship):
                if isinstance(unit, AIUnit):
                    self.aiunits.append(unit)
                else:
                    self.ships.append(unit) #add a ship to the ship list
                self.ship_list.add(unit) #add the ship to the sprites list
            elif isinstance(unit, Obstacle):
                self.units.append(unit)
                self.unit_list.add(unit)
            self.all_sprites_list.add(unit)
            self._set(grid_x,grid_y,grid_w,grid_h)
        else:
            print('Sorry: position taken: (x:{0}, y:{1}, w:{2}, h:{3})'.format(grid_x,grid_y,grid_w,grid_h))
            
    def add_door(self, grid_x=0, grid_y=0, grid_w=1, grid_h=1, unit_class=Door, value="", color=(0,0,0), img_src='', door_alpha = True, frame_flow=[0], frame_count=1):
        #add a unit that will be drawn to the board but will not hold a square in the grid
        #this is usually a red square indicating where other squares should be dragged to complete the task
        unit = unit_class(self,grid_x,grid_y,grid_w,grid_h,value,initcolor=color,img_src = img_src,door_alpha = door_alpha,frame_flow=frame_flow,frame_count=frame_count)
        self.unit_list.add(unit)
        self.units.append(unit)
        self.all_sprites_list.add(unit)

    def move_ok(self, ship_id, y,x):
        'move the ship in either ("T")op ("B")ottom ("L")eft or ("R")ight \n call with move(0, "T")'
        ship = self.ships[self.active_ship]
        #check direction and move if fields in that direction are free
        if x == -1 and y == 0 and self._isfree(ship.grid_x,ship.grid_y-1,ship.grid_w,1):
            self._move_unit(ship_id,0,-1)
        elif x == 1 and y == 0 and self._isfree(ship.grid_x,ship.grid_y+ship.grid_h,ship.grid_w,1):
            self._move_unit(ship_id,0,1)
        elif x == 0 and y == -1 and self._isfree(ship.grid_x-1,ship.grid_y,1,ship.grid_h):
            self._move_unit(ship_id,-1,0)
        elif  x == 0 and y == 1  and self._isfree(ship.grid_x+ship.grid_w,ship.grid_y,1,ship.grid_h):
            self._move_unit(ship_id,1,0)
        else:
            print("move impossible...")

    def move(self, ship_id, x, y, ai=False):
        'move the ship, diagonal move available only if non diagonal move would be possible'
        if ai == True:
            s = self.aiunits[ship_id]
        else:        
            s = self.ships[self.active_ship]
        #check direction and move if fields in that direction are free
        #set out what squares need checking if move has been taken in each direction
        up    = (s.grid_x, s.grid_y -1, s.grid_w, 1)
        down  = (s.grid_x, s.grid_y + s.grid_h, s.grid_w,1)
        left  = (s.grid_x - 1, s.grid_y, 1, s.grid_h)
        right = (s.grid_x + s.grid_w, s.grid_y, 1, s.grid_h)

        #assign 'area to check' to direction
        if   x ==  0 and y == -1: new_rect = up
        elif x ==  0 and y ==  1: new_rect = down
        elif x == -1 and y ==  0: new_rect = left
        elif x ==  1 and y ==  0: new_rect = right

        #diagonal move: prepare the 2 step move alternatives to check against        
        #alt1a -> alternative path 1 firt move: a, second move: b
        elif x <= -1 and y <= -1: #up-left
            alt1a = up
            alt1b = (s.grid_x - 1, s.grid_y-1, 1, s.grid_h)
            alt2a = left
            alt2b = (s.grid_x -1 , s.grid_y -1, s.grid_w, 1)
        elif x >=  1 and y <= -1: #up-right
            alt1a = up
            alt1b = (s.grid_x + s.grid_w, s.grid_y-1, 1, s.grid_h)
            alt2a = right
            alt2b = (s.grid_x+1, s.grid_y -1, s.grid_w, 1)
        elif x <= -1 and y >=  1: #down-left
            alt1a = down
            alt1b = (s.grid_x - 1, s.grid_y+1, 1, s.grid_h)
            alt2a = left
            alt2b = (s.grid_x-1, s.grid_y + s.grid_h, s.grid_w,1)
        elif x >=  1 and y >=  1: #down-right
            alt1a = down
            alt1b = (s.grid_x + s.grid_w, s.grid_y+1, 1, s.grid_h)
            alt2a = right
            alt2b = (s.grid_x+1, s.grid_y + s.grid_h, s.grid_w,1)
        mdir = [0,0]
        if x==0 or y==0:
            #standard move: check if positions are empty and move the unit 
            if self._isfree(*new_rect):
                self._move_unit(ship_id,ai,x,y)
            else:
                if ai == False:
                    s2.play()
        elif x != 0 and y != 0:
            #diagonal move simple path finder: check both alternatives in turn and move if possible
            #decreased number of checks to get the direction
            if self._isfree(*alt1a): #if move up or down possible change y in first alternative
                mdir[1]=y
                if self._isfree(*alt1b): #if move left or right possible change x in first alt.
                    mdir[0]=x
                else: mdir[0]=0
            elif self._isfree(*alt2a): #else if horizontal move possible change x first
                mdir[0]=x
                if self._isfree(*alt2b): #and if second move possible change y second
                    mdir[1]=y
                else: mdir[1]=0
            else:
                if ai == False:
                    s2.play()
            if mdir != [0,0]:
                self._move_unit(ship_id,ai,*mdir)
                
    def _move_unit(self, ship_id, ai, x, y):
        if ai == True:
            ship = self.aiunits[ship_id]
        else:        
            ship = self.ships[ship_id]
            s1.play()

        #remove ship from board grid - take off
        self._set(ship.grid_x,ship.grid_y,ship.grid_w,ship.grid_h,False)

        #change position of ship in ships list
        ship.grid_x += x
        ship.grid_y += y

        #place the ship back on board - land
        self._set(ship.grid_x,ship.grid_y,ship.grid_w,ship.grid_h,True)

        #update the sprite's position 
        ship.rect.topleft = [ship.grid_x*self.scale+1,ship.grid_y*self.scale+1]
        self.board_changed = True
     
    def _place_unit(self, ship_id, pos):
        ship = self.ships[ship_id]
        #remove ship from board grid - take off
        self._set(ship.grid_x,ship.grid_y,ship.grid_w,ship.grid_h,False)

        #change position of ship in ships list
        ship.grid_x = pos[0]
        ship.grid_y = pos[1]

        #place the ship back on board - land
        self._set(ship.grid_x,ship.grid_y,ship.grid_w,ship.grid_h,True)

        #update the sprite's position 
        ship.rect.topleft = [ship.grid_x*self.scale+1,ship.grid_y*self.scale+1]

    def activate_ship(self,x,y):
        'this only works on binary table'
        for each_ship in self.ships:
            if each_ship.grid_x <= x <= each_ship.grid_x + each_ship.grid_w-1 \
            and each_ship.grid_y <= y <= each_ship.grid_y + each_ship.grid_h-1:
                self.active_ship = each_ship.unit_id
                return True
        self.active_ship = -1
        return False

    @property
    def active_ship_pos(self):
        if self.active_ship > -1:
            ship = self.ships[self.active_ship]
            return (ship.grid_x,ship.grid_y)
        else:
            return (-1,-1)

    @property
    def active_val_len(self):
        if self.active_ship > -1:
            ship = self.ships[self.active_ship]
            return len(ship.value)
        else:
            return 0
            
        
    def update_ships(self,circle_lock_pos,**kwargs):
        for each_ship in self.ships:
            if each_ship.unit_id == self.active_ship:
                each_ship.color = each_ship.brighter
                if each_ship.outline_highlight:
                    each_ship.perm_outline_width = 3
            else:
                each_ship.color = each_ship.initcolor
                if each_ship.outline_highlight:
                    each_ship.perm_outline_width = each_ship.init_pow
            each_ship.update(self,point = circle_lock_pos)

        for each_unit in self.units:
            each_unit.update(self)
        
        for each_ai in self.aiunits:
            each_ai.update(self)
