#p - pitch - 0-99 - def 50
#a - amplitude/volume 0 - 200 def =100
#s - speed - 80 - 450 - def. 175
#g word gap
#-v sets the voice - voice filename +variant
#tts("'You pressed the letter: A'",1)
import os
import subprocess
import colorsys
from classes.simple_vector import Vector2
import random

def tts(text,s):
    if s==1:
        v="-s 190 -a 100 -p 75 -ven+m1 "
    elif s==2:
        v="-s 170 -a 100 -p 80 -ven+m2 "
    elif s==3:
        v="-s 175 -a 100 -p 80 -ven+m3 "
    elif s==4:
        v="-s 190 -a 100 -p 60 -ven+f1 "
    elif s==5:
        v="-s 170 -a 100 -p 75 -ven+f2 "
    elif s==6:
        v="-s 170 -a 100 -p 80 -ven+m2 "
        #v="-s 170 -a 100 -p 99 -ven+f2 "
        #v="-s 170 -a 100 -p 75 -g 5 -vpl+m1 "
    else:
        v="-s 100 -a 100 -p 75 -ven+m1 "
    #return os.system("espeak  "+v+"'"+text+"' " )

    subprocess.Popen("espeak  "+v+"'"+text+"' ", shell=True)

#espeak  -s 190 -a 100 -p 75 -ven+m1 "testing sound"

#those color functions take 3 values in range 0 - 255

#h - hue
#s - light s=0 white, s=255 full color
#v - dark v=0 dark, v=255 full color
def hsv_to_rgb(h,s,v):
    hsv = [h,s,v]
    hsv_clean = hsv
    for i in range(3):
        if hsv[i] <= 0:
            hsv_clean[i] = 0
        elif hsv[i] >= 255:
            hsv_clean[i] = 1
        else:
            hsv_clean[i] = float(hsv[i])/255.0

    rgb = colorsys.hsv_to_rgb(*hsv_clean)
    return [int(each*255) for each in rgb]

def rgb_to_hsv(r,g,b):
    #pass
    hsv = colorsys.rgb_to_hsv(r/255.0,g/255.0,b/255.0)
    hsv255 = [each*255 for each in hsv]
    return hsv255

def rr2(from1,to1,from2,to2,step=1):
    x = random.choice([-1,1])
    if x == -1:
        a = random.randrange(from1,to1,step)
    else:
        a = random.randrange(from2,to2,step)
    return a
    
def rr3(from1,to2, center, exclusion_zone,step=1):
    to1 = center-exclusion_zone
    from2 = center+exclusion_zone
    if from1 < to1 < from2 < to2:
        return rr2(from1, to1, from2, to2, step)
    
def rand_safe_curve(point,width,height):
    x_space = width - point[0] 
    y_space = height - point[1] 
 
    if x_space > point[0]:
        max_x = point[0]
    else:
        max_x = x_space
        
    if y_space > point[1]:
        max_y = point[1]
    else:
        max_y = y_space
        
    x = rr3(point[0]-max_x,point[0]+max_x, point[0], max_x//2)
    y = rr3(point[1]-max_y,point[1]+max_y, point[1], max_y//2)
    return [x,y]
    
def rand_safe_curve_short(point,width,height):
    x_space = width - point[0] 
    y_space = height - point[1] 
    #print(point)  
    if x_space > point[0]:
        max_x = point[0]
    else:
        max_x = x_space
    
    if y_space > point[1]:
        max_y = point[1]
    else:
        max_y = y_space
    x = rr3(point[0]-max_x,point[0]+max_x, point[0], max_x//2)
    y = rr3(point[1]-max_y,point[1]+max_y, point[1], max_y//2)
    return [x,y]
    
def simplified_points(first_point,last_point,width,height,x_center,y_center,step):
    pass
	
def third_point(point,width,height,scale):
    pass
    
def sqr(num):
    return num*num
 
def cube(num):
    return num*num*num

#points = [[200, 400], [300, 250], [450, 500], [500, 475]]
#points = [[beginning], [beginning_midifier], [end],[end_midifier]]
#points as Vector2
def DrawBezier(points):
    bezier_points = []
    t = 0.0
    while t < 1.02:  # Increment through values of t (between 0 and 1)
       	# Append the point on the curve for the current value of t to the list of Bezier points
        bezier_points.append(GetBezierPoint(points, t))
        t += 0.02
    return bezier_points

def GetBezierPoint(points, t):
    p1 = points[0] * cube(1.0 - t)
    p2 = points[1] * (3 * sqr(1.0 - t) * t)
    p3 = points[2] * cube(t)
    p4 = points[3] * (3 * (1.0 - t) * sqr(t))
    return p1 + p2 + p3 + p4

def GetBezierPoint2(points, t):
    p1 = vectmult(cube(1.0 - t), points[0])
    p2 = vectmult((3 * sqr(1.0 - t) * t), points[1])
    p3 = vectmult(cube(t), points[2])
    p4 = vectmult((3 * (1.0 - t) * sqr(t)), points[3])
    return [round(p1[0] + p2[0] + p3[0] + p4[0]), round(p1[1] + p2[1] + p3[1] + p4[1])] 

def inversions(p):
    lp = len(p)
    total_inversions = 0
    for i in range(lp):#pick each number from left to right
        for  j in range(i,lp):#and check it against any numbers to the right
            if p[i] > p[j]:   #if any of them are greater than the number itself
                total_inversions += 1
    return total_inversions
    
def inversions_2_old(p):
    lp = len(p)
    total_inversions = 0
    for i in range(lp):#pick each number from left to right
        inv_each = 0
        for  j in range(i,lp):#and check it against any numbers to the right
            if p[i] > p[j]:   #if any of them are greater than the number itself
                inv_each += 1
        total_inversions += inv_each
    return total_inversions
    
def inversions_3_old(p):
    lp = len(p)
    inv_count = []
    for i in range(lp):
        inv_each = 0
        for  j in range(i,lp):
            if p[i] > p[j]:
                inv_each += 1
        inv_count.append(inv_each)
    return sum(inv_count)
       	