import threading
import os
import subprocess
import signal

class Speaker(threading.Thread):
    def __init__(self):
        self.enabled = True
        if self.enabled:
            self.engine = "espeak"
            self._sock = False
            threading.Thread.__init__(self)
            if self.engine == "espeak":
                voices = ["-s 190 -a 100 -p 75 -ven+m1 ", "-s 170 -a 100 -p 80 -ven+m2 ","-s 175 -a 100 -p 80 -ven+m3 ","-s 190 -a 100 -p 60 -ven+f1 ","-s 170 -a 100 -p 75 -ven+f2 ","-s 170 -a 100 -p 80 -ven+m2 "]
                attr = voices[5]        
                self.process = subprocess.Popen(['espeak',attr], stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
                #stdout and stderr only used to hide the messages from terminal
    def run(self):
        pass
        
    def stop_server(self):
        if self.enabled:
            self.process.stdin.close()
            try:
                os.kill(self.process.pid, signal.SIGTERM)
            except OSError:
                print("Error killing the espeak or festival server")
        
    def say(self,text,voice=1):
        if self.enabled:
            if self.engine == "espeak":
                text = text + "\n"
                self.process.stdin.write(text.encode())
                self.process.stdin.flush()
        else:
            pass