import classes.level_controller as lc
import classes.game_driver as gd
import classes.extras as ex

import classes.board
import random
#import colorsys


class Board(gd.BoardGame):
    def __init__(self, mainloop, speaker, config,  screen_w, screen_h):
        self.level = lc.Level(self,1,1)
        gd.BoardGame.__init__(self,mainloop,speaker,config,screen_w,screen_h,11,9)
        
        
    def create_game_objects(self, level = 1):
        #create non-movable objects
        
        s = random.randrange(30, 80)
        v = random.randrange(200, 255)
        h = random.randrange(0, 255)
        color = ex.hsv_to_rgb(h,s,v)
        
        data = [11,9]
        #stretch width to fit the screen size
        data[0] = self.get_x_count(data[1],even=None)
        self.data = data
        
        self.mainloop.info.hide_buttons(0,0,0,0,1,0,1)
        
        self.layout.update_layout(data[0],data[1])
        scale = self.layout.scale
        self.board.level_start(data[0],data[1],scale)
        #AyeKiddo??? 
        self.board.add_unit(0,0,data[0],2,classes.board.Label,"pySioGame",color,"",0)
        #self.board.add_unit(0,2,data[0],2,classes.board.Label,["Pre-school Educational Activities Pack","by Ireneusz Imiolek"],color,"",3)
        #self.board.add_unit(0,4,data[0],4,classes.board.Label,["","Sound effects by cfork - freesound.org","Images by various authors who contributed their works to openclipart.org","Please view credits.txt for more info about authors of media files used in this project"],color,"",8) 
        
        self.board.add_unit(0,2,data[0],1,classes.board.Label,"Educational Activity Pack",color,"",2)
        self.board.add_unit(0,3,data[0],1,classes.board.Label,"for children aged 3 - 10",color,"",3)
        self.board.add_unit(0,4,data[0],1,classes.board.Label,"by Ireneusz Imiolek",color,"",3)
        self.board.add_unit(0,5,data[0],1,classes.board.Label,"",color,"",3)   
        self.board.add_unit(0,6,data[0],1,classes.board.Label,"Sound effects by cfork - freesound.org",color,"",7)
        self.board.add_unit(0,7,data[0],1,classes.board.Label,"Images by various authors who contributed their works to openclipart.org",color,"",7)
        self.board.add_unit(0,8,data[0],1,classes.board.Label,"Please view credits.txt for more info about authors of media files used in this project",color,"",7)
        self.outline_all(1,1)
        
    def handle(self,event):
        gd.BoardGame.handle(self, event) #send event handling up

    def update(self,game):
        game.fill((255,255,255))
        gd.BoardGame.update(self, game) #rest of painting done by parent

    def check_result(self):
        pass