import classes.level_controller as lc
import classes.game_driver as gd
import classes.extras as ex

import classes.board
import random
#import colorsys


class Board(gd.BoardGame):
    def __init__(self, mainloop, speaker, config,  screen_w, screen_h):
        self.level = lc.Level(self,99,1)
        gd.BoardGame.__init__(self,mainloop,speaker,config,screen_w,screen_h,11,9)
        
        
    def create_game_objects(self, level = 1):
        #create non-movable objects
        
        self.board.draw_grid = False
        #s = random.randrange(30, 80)
        #v = random.randrange(200, 255)
        #h = random.randrange(0, 255)
        #color = ex.hsv_to_rgb(h,s,v)
        #mask_color = ((216,216,216))
        #color = ((255,255,255))
        #white = ((253,253,253))
        color = ((252,252,252))
        mask_color = color
        data = [7,3]
        
        #stretch width to fit the screen size
        max_x_count = self.get_x_count(data[1],even=False)
        if max_x_count > 7:
            data[0] = max_x_count
            
        self.data = data
        self.center = self.data[0] // 2
        self.mainloop.info.hide_buttons(1,0,0,0,1,1,1)
        
        self.layout.update_layout(data[0],data[1])
        scale = self.layout.scale
        self.board.level_start(data[0],data[1],scale)
        images = ["m_img{0}a.png".format(i) for i in range(1,20)]
        masks  = ["m_img{0}b.png".format(i) for i in range(1,20)]
        choice = [x for x in range(0,19)]
        shuffled = choice[:]
        random.shuffle(shuffled)
        self.chosen = shuffled[0:5]
        
        self.shuffled2 = self.chosen[:]
        random.shuffle(self.shuffled2)
        x = self.center - 2
        for i in range(5):
            self.board.add_door(x+i,0,1,1,classes.board.Door,str(self.chosen[i]),mask_color,masks[self.chosen[i]])
            self.board.add_unit(x+i,2,1,1,classes.board.ImgShip,str(self.shuffled2[i]),color,images[self.shuffled2[i]])

        for each in self.board.ships:
            self.board.all_sprites_list.move_to_front(each) 
            each.outline = False
            each.readable = False
            
        for each in self.board.units:
            each.outline = False
        #self.board.add_unit(0,3,1,1,classes.board.ImgShip,"",apple_bg,"m_img1a.png")

        """
        self.board.add_unit(0,0,data[0],2,classes.board.Label,"pySioGame / EdApp / Add Up",color,"",0)
        #self.board.add_unit(0,2,data[0],2,classes.board.Label,["Pre-school Educational Activities Pack","by Ireneusz Imiolek"],color,"",3)
        #self.board.add_unit(0,4,data[0],4,classes.board.Label,["","Sound effects by cfork - freesound.org","Images by various authors who contributed their works to openclipart.org","Please view credits.txt for more info about authors of media files used in this project"],color,"",8) 
        
        self.board.add_unit(0,2,data[0],1,classes.board.Label,"Educational Activity Pack",color,"",2)
        self.board.add_unit(0,3,data[0],1,classes.board.Label,"for children aged 3 - 10",color,"",3)
        self.board.add_unit(0,4,data[0],1,classes.board.Label,"by Ireneusz Imiolek",color,"",3)
        self.board.add_unit(0,5,data[0],1,classes.board.Label,"",color,"",3)   
        self.board.add_unit(0,6,data[0],1,classes.board.Label,"Sound effects by cfork - freesound.org",color,"",7)
        self.board.add_unit(0,7,data[0],1,classes.board.Label,"Images by various authors who contributed their works to openclipart.org",color,"",7)
        self.board.add_unit(0,8,data[0],1,classes.board.Label,"Please view credits.txt for more info about authors of media files used in this project",color,"",7)
        self.outline_all(1,1)
        """
        
    def handle(self,event):
        gd.BoardGame.handle(self, event) #send event handling up

    def update(self,game):
        game.fill((255,255,255))
        gd.BoardGame.update(self, game) #rest of painting done by parent

    def check_result(self):
        if self.changed_since_check:
            #checking copied from number sorting game and re-done
            if self.board.grid[0][self.center-2:self.center+3] == [1,1,1,1,1]: #self.solution_grid:
                ships = []
                units = []
                #collect value and x position on the grid from ships list
                for i in range(5):
                    ships.append([self.board.ships[i].grid_x, int(self.board.ships[i].value)])
                    units.append([self.board.units[i].grid_x, int(self.board.units[i].value)])
                #ships_sorted = sorted(ships)
                ships.sort()
                units.sort()
                correct = True
                for i in range(5):
                    if i < 4:
                        if ships[i][1] != units[i][1]:
                            correct = False
                if correct == True:
                    self.level.next_board()
                else:
                    self.say("Sorry! It is wrong.",6)
                    self.changed_since_check = False