import classes.level_controller as lc
import classes.game_driver as gd
import classes.extras as ex

import pygame
import classes.board
import random
import colorsys


class Board(gd.BoardGame):
    def __init__(self, mainloop, speaker, config,  screen_w, screen_h):
        self.level = lc.Level(self,1,1)
        gd.BoardGame.__init__(self,mainloop,speaker,config,screen_w,screen_h,11,9)
        
        
    def create_game_objects(self, level = 1):
        #create non-movable objects
        self.board.draw_grid = False
        s = random.randrange(30, 80)
        v = random.randrange(200, 255)
        h = random.randrange(0, 225)
        #ex.hsv_to_rgb(h,s,v)
        #rgb = colorsys.hsv_to_rgb(h,s,v)
        letter_color = ex.hsv_to_rgb(h,s,v)
        white = ((255,255,255))
        outline_color =  ex.hsv_to_rgb(h,s+50,v-50)
        frame_color = [255,255,255]
        card_color = ex.hsv_to_rgb(h+10,s-25,v)

        data = [15,10]
        #stretch width to fit the screen size
        data[0] = self.get_x_count(data[1],even=False)
        if data[0]<15:
            data[0]=15
        self.data = data
        self.x_offset = (data[0]-15)//2
        self.mainloop.info.hide_buttons(0,0,0,0,1,0,1)

        self.layout.update_layout(data[0],data[1])
        scale = self.layout.scale
        self.board.level_start(data[0],data[1],scale)
        
        #self.word_list = ['Ant', 'Boat', 'Cat', 'Duck', 'Elephant', 'Fish', 'Grapes', 'House', 'Igloo', 'Jar', 'Key', 'Lion', 'Mouse', 'Notebook', 'Owl', 'Parrot', 'Queen', 'Rabbit', 'Sun', 'Teapot', 'Umbrella', 'Violin', 'Window', 'Xylophone', 'Yarn', 'Zebra']
        t_area = chr(189) + "ah"

        self.shape_names = ["Equilateral Triangle", "Isosceles Triangle", "Acute Triangle", "Right Triangle", "Obtuse Triangle", "Square", "Rectangle", "Trapezium", "Isosceles Trapezium", "Rhombus", "Parallelogram", "Pentagon", "Hexagon", "Circle", "Ellipse"]
        self.shape_areas = [t_area, t_area, t_area, chr(189) + "ab", t_area, "a " + chr(215) + " a", "a " + chr(215) + " b", chr(189) + "(a+b) " + chr(215) + " h", chr(189) + "(a+b) " + chr(215) + " h", "a " + chr(215) + " h", "a " + chr(215) + " h", "too long", "too long", "pi" + chr(215) + "r"+chr(178), "pi" + chr(215) + "a" + chr(215) + "b"]
        self.shape_circ = ["3a", "a + 2b", "a + b + c", "a + b + c", "a + b + c", "4a", "2a + 2b", "a + b + c + d", "a + b + 2c", "4a", "2a + 2b", "5a", "6a", "2" + chr(215) + "pi" + chr(215) + "r", "too long"]
        
        x = self.x_offset
        #x2 = (data[0] - (26 - data[0]))//2
        y = 0
        
        for i in range(15):
            self.board.add_unit(x,y,1,1,classes.board.Letter,self.shape_names[i],white,"",2)
            #self.board.ships[i].perm_outline = True
            #self.board.ships[i].set_outline(outline_color,1)
            self.board.ships[-1].font_color=(255,255,255,0)
            x += 1
            #if x >= data[0]:
            #    x = x2
            #    y = data[1]-1

        x=(data[0]-4)//2
        y=1
        
        self.shape_count = len(self.board.ships) 
        
        #Card
        self.board.add_unit(x-2,y+1,9,2,classes.board.Letter,"Equilateral Triangle",card_color,"",2)
        #self.board.add_unit(x-2,y+2,8,1,classes.board.Letter,"Triangle",card_color,"",2)

        self.board.add_unit(x+2,y+3,5,1,classes.board.Letter,"area:",card_color,"",3)
        self.board.add_unit(x+2,y+4,5,1,classes.board.Label,t_area,card_color,"",3)
        self.board.add_unit(x+2,y+5,5,1,classes.board.Letter,"circumference:",card_color,"",3)
        self.board.add_unit(x+2,y+6,5,1,classes.board.Label,"3a",card_color,"",3)
        #self.board.add_unit(x+2,y+5,1,1,classes.board.Label,"v =",card_color,"",3)
        #self.board.add_unit(x+3,y+5,3,1,classes.board.Label,"???",card_color,"",3)
        #self.board.add_unit(x+2,y+5,4,1,classes.board.Label,"",card_color,"",2)

        #self.board.add_unit(x-2,y+6,4,1,classes.board.Label,"",card_color,"",2)

        #frame size 288 x 216        
        self.board.add_unit(x-2,y+3,4,4,classes.board.MultiImgSprite,self.shape_names[0],card_color,"flashcard_shapes.png")
        
        #Frame
        self.board.add_unit(0,y,x-2,data[1]-2,classes.board.Obstacle,"",frame_color)
        self.board.add_unit(x+7,y,x-2,data[1]-2,classes.board.Obstacle,"",frame_color)
        self.board.add_unit(x-2,y,9,1,classes.board.Obstacle,"",frame_color)
        self.board.add_unit(x-2,y+7,9,1,classes.board.Obstacle,"",frame_color)
        
        self.board.add_door(x-2,y+1,9,6,classes.board.Door,"",card_color,"")
        
        self.board.add_door(x-5,0,15,1,classes.board.Door,"",card_color,"flashcard_shapes_72.png")
        #self.board.add_door(x,y+2,4,3,classes.board.Door,"",card_color,"")
        
        
        self.board.units[6].door_outline = True
        self.board.all_sprites_list.move_to_front(self.board.units[6])
        self.board.all_sprites_list.move_to_front(self.board.units[7])
        
        self.slide = self.board.ships[self.shape_count+3]
        self.slide.build_frame_flow(self.shape_count+3) 
        self.slide.correction = True
        #self.slide.set_outline(outline_color,1)
        self.slide.perm_outline = True
        
        for each in self.board.ships:
            each.draggable = False
            each.highlight = False
       
        #self.outline_all(1,1)
        
    def handle(self,event):
        gd.BoardGame.handle(self, event) #send event handling up
        if event.type == pygame.MOUSEBUTTONUP:
            self.active_item = self.board.ships[self.board.active_ship]
            if self.active_item.unit_id < self.shape_count:
                self.create_card(self.active_item)

    def create_card(self, active):
        #self.say(active.value[0])
        self.board.ships[self.shape_count].value = self.shape_names[active.unit_id]
        self.board.units[0].value = self.shape_areas[active.unit_id]
        self.board.units[1].value = self.shape_circ[active.unit_id]
        self.slide.value = self.shape_names[active.unit_id]

        self.mainloop.redraw_needed[0] = True
        self.slide.set_frame(active.unit_id)
        self.board.active_ship = -1
        
    def update(self,game):
        game.fill((255,255,255))
        gd.BoardGame.update(self, game) #rest of painting done by parent

    def check_result(self):
        pass