import classes.level_controller as lc
import classes.game_driver as gd

import classes.board
import random
import colorsys

class Board(gd.BoardGame):
    def __init__(self, mainloop, speaker, config, screen_w, screen_h):
        self.level = lc.Level(self,1,1)
        gd.BoardGame.__init__(self,mainloop,speaker,config,screen_w,screen_h,14,8)
        
    def create_game_objects(self, level = 0):
        #create movable objects
        s = random.randrange(150, 205, 3)/255
        v = random.randrange(150, 205, 3)/255
        pos_x = 0
        pos_y = 0
        data = [14,8]
        self.data = data
        for i in range(65,91):
            h = random.randrange(0, 255, 3)/255
            rgb = colorsys.hsv_to_rgb(h,s,v)
            color = [round(each*255) for each in rgb]
            #create uppercase letters
            self.board.add_unit(pos_x,pos_y,1,1,classes.board.Letter,chr(i),color)
            #create lowercase letters
            self.board.add_unit(pos_x+1,pos_y,1,1,classes.board.Letter,chr(i+32),color)
            pos_x +=2
            if pos_x >= self.layout.x_count-1:
                pos_x = 0
                pos_y +=1
        
    def handle(self,event):
        gd.BoardGame.handle(self, event) #send event handling up

    def update(self,game):
        game.fill((255,255,255))
        gd.BoardGame.update(self, game) #rest of painting done by parent