import classes.level_controller as lc
import classes.game_driver as gd
import classes.extras as ex
import pygame

import classes.board
import random
import colorsys
from game_boards import laby_class

class Board(gd.BoardGame):
    def __init__(self, mainloop, speaker, config, screen_w, screen_h):
        self.level = lc.Level(self,5,18)
        gd.BoardGame.__init__(self,mainloop,speaker,config,screen_w,screen_h,5,4)
        
        
    def create_game_objects(self, level = 1):
        #create non-movable objects
        
        s = random.randrange(150, 190, 5)
        v = random.randrange(230, 255, 5)
        h = random.randrange(0, 255, 5)
        color0 = ex.hsv_to_rgb(h,40,230) #highlight 1
        color1 = ex.hsv_to_rgb(h,70,v) #highlight 2
        color2 = ex.hsv_to_rgb(h,s,v) #normal color
        color3 = ex.hsv_to_rgb(h,230,100)
        white = ((255,255,255))

        #all_grid_sizes_at_1024_768 = [[7, 4],[8, 5],[9, 6],[10, 7],[11, 7],[12, 8],[13, 9],[14, 9],[15, 10],[16, 11],[17, 11],[18, 12],[19, 13],[20, 14],[21, 14],[22, 15],[23, 16],[24, 16],[25, 17],[26, 18],[27, 19],[28, 19],[29, 20],,[30,21]]
        grid_sizes = [[5, 4],[7, 5],[8, 6],[9, 7],[11, 8],[12, 9],[14, 10],[15, 11],[17, 12],[18, 13],[19, 14],[21, 15],[22, 16],[24, 17],[25, 18],[26, 19],[28, 20],[29, 21],[30,22]]        

        data = grid_sizes[self.level.lvl-1]
        
        #rescale the number of squares horizontally to better match the screen width
        data[0] = self.get_x_count(data[1],even=False)
        
        if self.level.lvl == 1 and self.level.game_step == 1 and self.config.read_inst:
            self.say("Take your sheep to the rest of the herd.",2)  

        self.data = data
        
        self.mainloop.info.hide_buttons(0,1,1,1,1,1,1)
        
        self.layout.update_layout(data[0],data[1])
        scale = self.layout.scale
        self.board.level_start(data[0],data[1],scale)
        
        self.mylaby = laby_class.laby(data[0],data[1],0,0,scale)
        self.mylaby.generate_laby()
        self.person = laby_class.Person(self.mylaby,0,0,scale,"sheep.png")
        self.board.ship_list.add(self.person)
        self.board.all_sprites_list.add(self.person)
        #self.board.add_unit(data[0]-1,data[1]-1,1,1,classes.board.Obstacle,"",(255,200,200),"",2)
        self.board.add_door(data[0]-1,data[1]-1,1,1,classes.board.Door,"",((255,255,255)),"sheep_herd.png")
        self.board.units[0].outline=False        
        self.board.all_sprites_list.move_to_front(self.person)         


    def handle(self,event):
        gd.BoardGame.handle(self, event) #send event handling up
        """ Movement of the yellow circle """
        if self.show_msg == False:
            if event.type == pygame.KEYDOWN:
                self.mainloop.redraw_needed[0] = True
                if   event.key == pygame.K_RIGHT:
                	self.person.move(laby_class.const.right)
                	self.board.s1.play()
                elif event.key == pygame.K_LEFT:
                	self.person.move(laby_class.const.left)
                	self.board.s1.play()
                elif event.key == pygame.K_UP:
                	self.person.move(laby_class.const.up)
                	self.board.s1.play()
                elif event.key == pygame.K_DOWN:
                	self.person.move(laby_class.const.down)
                	self.board.s1.play()
                
            elif event.type == pygame.KEYUP:
                self.check_result()


    def update(self,game):
        game.fill((255,255,255))

        gd.BoardGame.update(self, game) #rest of painting done by parent
        if self.show_msg == False:    
            self.person.poll()
            self.mylaby.show(game)  
            self.person.show2()      

    def check_result(self):
        target = pygame.sprite.spritecollide(self.board.units[0], self.board.ship_list, False, collided = None)
        if len(target)>0:
            self.level.next_board()
