import classes.level_controller as lc
import classes.game_driver as gd
import pygame
import classes.board
import random
import colorsys

import os.path
import pygame.mixer
sounds = pygame.mixer
sounds.init()


sound_12 = '26875__cfork__cf-fx-batch-jingle-glock-n-kloing.ogg'
s12 = sounds.Sound(os.path.join('sounds', sound_12))

class Board(gd.BoardGame):
    def __init__(self, mainloop, speaker, config,  screen_w, screen_h):
        self.level = lc.Level(self,99,1)
        gd.BoardGame.__init__(self,mainloop,speaker,config,screen_w,screen_h,9,10)
        
        
    def create_game_objects(self, level = 1):
        #create non-movable objects
        s = random.randrange(150, 205, 5)/255
        v = random.randrange(150, 205, 5)/255
        h = random.randrange(0, 255, 5)/255
        rgb = colorsys.hsv_to_rgb(h,s,v)
        color = [round(each*255) for each in rgb]

        self.grass_bg = [51,128,0]
        self.white = [255,255,255]
        
        self.ticket = LottoTicket()
        
        #data = [x_count, y_count, range_from, range_to, max_sum_range, image]
        if self.level.lvl == 1:
            data = [11,10]

        #rescale the number of squares horizontally to better match the screen width
        #data[0] = self.get_x_count(data[1],even=None)
        self.data = data
        self.solution_grid = [0,0,0,1,1,1,1,1,0,0,0]
        self.layout.update_layout(data[0],data[1])
        self.board.level_start(data[0],data[1],self.layout.scale)
        
        self.board.add_unit(4,0,1,1,classes.board.Letter,"50",color,"",1)
        self.board.add_unit(5,0,1,1,classes.board.Letter,"5",color,"",1)
        self.board.add_unit(6,0,1,1,classes.board.Letter,"11",color,"",1)
        self.board.add_unit(7,0,1,1,classes.board.Letter,"2",color,"",1)      
        self.board.add_unit(7,2,1,1,classes.board.Letter,"0",color,"",1)      
        self.board.add_unit(8,2,1,1,classes.board.Letter,"0",color,"",1)        
        self.board.add_unit(2,2,1,1,classes.board.Letter,"0",color,"",1)
        self.board.add_unit(3,2,1,1,classes.board.Letter,"45",color,"",1)
        self.board.add_unit(4,2,1,1,classes.board.Letter,"49",color,"",1)
        self.board.add_unit(5,2,1,1,classes.board.Letter,"6",color,"",1)        
        self.board.add_unit(6,2,1,1,classes.board.Letter,"10",color,"",1)
        for i in range(1,10):
            self.board.add_unit(i,3,1,1,classes.board.Letter,str(i),color,"",1)
        
        self.board.add_door(3,0,5,1,classes.board.Door,"",color,"")
        self.board.units[0].door_outline = True
        x=0
        y=5
        for i in range(10):
            self.board.add_unit(x,y,5,1,classes.board.Label,"",color,"",4)
            y += 1
            if i == 4:
                x = 6
                y = 5

    def handle(self,event):
        gd.BoardGame.handle(self, event) #send event handling up

    def update(self,game):
        game.fill((255,255,255))
        #game.fill(self.grass_bg)
        gd.BoardGame.update(self, game) #rest of painting done by parent
    
    def reset(self):
        for i in range(10):
            self.board.units[i].value = ""
            
    def check_result(self):
        result = [" " for i in range(self.data[0])]
        self.reset()
        #if self.changed_since_check:
        if self.board.grid[0] == self.solution_grid:
            for i in range(len(self.board.ships)):
                if self.board.ships[i].grid_y == 0:
                    if len(self.board.ships[i].value) > 0:
                        result[self.board.ships[i].grid_x] = int(self.board.ships[i].value)
            #result_s = ''.join(result).strip()
            #if self.word == result_s:
            #    self.level.next_board()
            #print(result)
            #[' ', ' ', '3', '49', '5', '11', '2', ' ', ' ']
            #print("result", end = ": ")
            #print(result)
            if result[3] <= 10 and result[4] > 11 and result[5] < 10 and result[6] >= 10 and result[7] < 10:
                a = self.ticket.draw_ticket(result[3],result[4],result[5],result[6],result[7])
                #print(a)                
                for i in range(len(a)):
                    self.board.units[i+1].value = str(a[i])
                self.mainloop.redraw_needed[0]=True
                    
        #print("Game completed")
        #self.game_reset()
        """
        if self.changed_since_check:
            self.result = []
            for each_list in self.board.grid:
                total = 0
                i = 0
                for each_item in each_list:
                    if i > 0:
                        total +=  each_item
                    i += 1
                self.result.append(total)
                
            if self.result == self.num_list:
                self.level.next_board()
            else:
                self.say("Please try again.",6)
                self.changed_since_check = False
        """

class LottoTicket:
    'Initializes and creates a lottery ticket'
    def __init__(self):
        self._set_game()

    def _set_game(self,first=49,f_count=6,second=0,s_count=0):
        self.first = first
        self.f_count = f_count
        self.second = second
        self.s_count = s_count
        self.base1 = [x for x in range(1,self.first+1)]
        self.base2 = [x for x in range(1,self.second+1)]
        self._restart()
        
    def _restart1(self):
        self.draw_set1 = self.base1[:]

    def _restart2(self):
        self.draw_set2 = self.base2[:]

    def _restart(self):
        self._restart1()
        self._restart2()
        
    def _draw_number(self,nl):
        'draws a random index of a number from a given list retuns the value and removes the position on the list, if only 1 element supplied it sends it back.'
        nllen = len(nl)
        if nllen == 1:
            index = 0
        else:
            numbers = [x for x in range(0,nllen)]
            index = random.choice(numbers)
        x = nl[index]
        del(nl[index])
        return x

    def _draw_line(self,nl,count):
        if len(nl) >= count:
            line = []
            for i in range(0,count):
                line.append(self._draw_number(nl))
            return sorted(line)

    def draw_ticket(self,lines=1,first=49,f_count=6,second=0,s_count=0):
        'prints the random lottery numbers, trying to use unique numbers in each line \
        however if large number of lines does not allow that, the script refills the numbers \
        and picks another group of non-repeating numbers. \n\
        Parameters available:\n\
        lines - number of lines to play:\n\
        first - limit of first range ie. 50 for EuroMillions,\n\
        f_count - count of numbers drawn out of first range, ie. 5,\n\
        second - limit of second range ie. 11 in EuroMillions, or 0 in other games\n\
        s_count - count of numbers drawn out of second range, ie. 2'
        self._set_game(first,f_count,second,s_count)
        lotto_ticket = []
        for i in range(0,lines):
            if len(self.draw_set1) < self.f_count:
                self._restart1()
            if len(self.draw_set2) < self.s_count:
                self._restart2()
            lotto_set = []
            lotto_set.append(self._draw_line(self.draw_set1,self.f_count))
            if self.s_count > 0:
                lotto_set.append(self._draw_line(self.draw_set2,self.s_count))
            lotto_ticket.append(lotto_set)
        return lotto_ticket
        #for each_line in lotto_ticket:
        #    print(each_line)
