import classes.level_controller as lc
import classes.game_driver as gd
import classes.extras as ex

import classes.board
import random
import colorsys

class Board(gd.BoardGame):
    def __init__(self, mainloop, speaker, config,  screen_w, screen_h):
        self.level = lc.Level(self,99,5)
        gd.BoardGame.__init__(self,mainloop,speaker,config,screen_w,screen_h,23,9)
        
        
    def create_game_objects(self, level = 1):
        #create non-movable objects
        
        s = random.randrange(150, 225, 5)
        v = random.randrange(190, 225, 5)
        h = random.randrange(0, 255, 5)
        color0 = ex.hsv_to_rgb(h,40,230) #highlight 1
        color1 = ex.hsv_to_rgb(h,70,v) #highlight 2
        color2 = ex.hsv_to_rgb(h,s,v) #normal color
        color3 = ex.hsv_to_rgb(h,230,100)
        #color4 = color0
        #apple_bg = [255,255,255]

        #data = [x_count, y_count, range_from, range_to, max_sum_range, image]
        if self.level.lvl == 1:
            data = [23,9]
        elif self.level.lvl == 2:
            data = [23,9]
            color1 = color0
        elif self.level.lvl == 3:
            data = [23,9]
            color1 = color2 = color0
        elif self.level.lvl == 4:
            data = [23,9]
            color1 = color2 = color0
        #elif self.level.lvl == 5:
        #    data = [23,9]
        #    color0 = (0,0,0)
        elif self.level.lvl == 5:
            data = [23,9]
            color2 = color1 = color0 = (0,0,0)
            color3 = (40,40,40)
        self.data = data
        #self.layout.update_layout(data[0],data[1])
        self.board.level_start(data[0],data[1],self.layout.scale)
        
        num1 = random.randrange(1,10)
        num2 = random.randrange(1,10)
        self.solution = [num1,num2,num1 * num2]
        
        unique = set()
        for i in range(1,10):
            for j in range(1,10):
                if i == num1 and j == num2: color=color0
                elif i == num1 or j == num2: color=color1
                elif self.level.lvl == 2 and (i == num2 or j == num1):color=color1
                else: color = color2
                mul = i*j
                unique.add(mul)
                caption = " " + str(mul) + " "
                self.board.add_unit(i-1,j-1,1,1,classes.board.Label,caption,color,"",2)
        self.board.add_unit(9,0,1,9,classes.board.Obstacle,"",color3)   
        unique = sorted(unique) 
        #draw outline with selectable numbers
        self.multi = dict()
        s = 180
        v = 240
        h = 7
        color = ex.hsv_to_rgb(h,s,v)
        x = 11
        y = 0
        for i in range(9):
            x += 1
            color = ex.hsv_to_rgb(h*i,s,v)
            self.multi[str(unique[i])]=i
            caption = str(unique[i])
            self.board.add_unit(x,y,1,1,classes.board.Letter,caption,color,"",2)
        x=14
        y=4
        #? x 5 = 25
        captions = [str(num1*num2),chr(247),str(num1),"="]
        if self.level.lvl < 4:
            color = self.board.ships[self.solution[1]-1].initcolor
        else:
            color = (255,255,255)#color4
        for i in range(4):
            self.board.add_unit(x+i,y,1,1,classes.board.Label,captions[i],color,"",2)

        self.outline_all(0,1)
            
        self.board.add_door(18,y,1,1,classes.board.Door,"",color,"")
        self.board.units[86].door_outline = True
        self.board.all_sprites_list.move_to_front(self.board.units[86]) 

    def handle(self,event):
        gd.BoardGame.handle(self, event) #send event handling up

    def update(self,game):
        game.fill((255,255,255))
        gd.BoardGame.update(self, game) #rest of painting done by parent

    def check_result(self):
        if self.changed_since_check:
            if self.board.grid[4][18]:
                sol = self.board.ships[self.solution[1]-1]
                if sol.grid_x == 18 and sol.grid_y == 4:
                    tts = "Perfect! "+str(self.solution[2])+" divided by "+str(self.solution[0])+" equals "+str(self.solution[1])
                    self.level.next_board(tts)
                else:
                    self.say("Sorry! It is wrong.",6)
                    self.changed_since_check = False